// CountPoemLines.jsx
// Подсчет строк стихотворного текста в документе InDesign с возможностью выбора нескольких стилей.

if (app.documents.length > 0) {
    var doc = app.activeDocument;
    var poemStyles = [];
    var totalLines = 0;

    // Получаем все стили абзацев (исключаем "[Basic Paragraph]")
    var allParagraphStyles = doc.paragraphStyles.everyItem().getElements();
    var filteredStyles = [];
    for (var i = 0; i < allParagraphStyles.length; i++) {
        if (allParagraphStyles[i].name !== "[Basic Paragraph]") {
            filteredStyles.push(allParagraphStyles[i]);
        }
    }

    // Создаем диалог
    var dialog = new Window("dialog", "Подсчет строк стихотворений");
    dialog.orientation = "column";
    dialog.alignChildren = "fill";
    dialog.spacing = 10;
    dialog.margins = 16;


    // Группа чекбоксов для стилей
    var checkboxGroup = dialog.add("panel", undefined, "Выберите стили стихотворений");
    checkboxGroup.orientation = "column";
    checkboxGroup.alignChildren = "left";
    var styleCheckboxes = [];
    for (var i = 0; i < filteredStyles.length; i++) {
        styleCheckboxes.push(checkboxGroup.add("checkbox", undefined, filteredStyles[i].name));
    }


    // Кнопка OK
    var buttonGroup = dialog.add("group");
    buttonGroup.orientation = "row";
    buttonGroup.alignment = "right";
    buttonGroup.add("button", undefined, "OK");

    // Показываем диалог
    if (dialog.show() === 1) {


        // Получаем выбранные стили
        for (var i = 0; i < styleCheckboxes.length; i++) {
            if (styleCheckboxes[i].value) {
                poemStyles.push(filteredStyles[i]);
            }
        }

        if (poemStyles.length === 0) {
            alert("Не выбрано ни одного стиля стихотворения.", "Подсчет строк");
            exit();
        }

        // Подсчет строк
        var textFrames = doc.textFrames.everyItem().getElements();
        for (var i = 0; i < textFrames.length; i++) {
            var tf = textFrames[i];
            var paragraphs = tf.paragraphs.everyItem().getElements();
            for (var j = 0; j < paragraphs.length; j++) {
                var p = paragraphs[j];
                for (var s = 0; s < poemStyles.length; s++) {
                    if (p.appliedParagraphStyle === poemStyles[s]) {
                        totalLines += p.lines.length;
                        break;
                    }
                }
            }
        }

        alert("Количество строк стихотворного текста: " + totalLines, "Подсчет строк");

    } else {
        exit();
    }

} else {
    alert("Нет открытых документов.", "Подсчет строк стихотворений");
}